/****************************************************************************
FERAL ROBOT - URBAN TAPESTRIES (http://urbantapestries.org/)
Linux-based robot client for gumstix platform
Author: Dima Diall
****************************************************************************/

#ifndef ADCHW_H
#define ADCHW_H

#include <stdint.h>

// ADC input range definition
#define ADC_CHANNELS        8
#define ADC_RESOL_BITS      10
#define ADC_SCALE_MAX       (1 << ADC_RESOL_BITS)
#define ADC_REF_VOLT        5.0

// Convert ADC discrete output to continuous reference voltage range
#define CONV_ADC(adc_val)   ((ADC_REF_VOLT * (float) (adc_val)) / ADC_SCALE_MAX)

int read_sensor(int adc_fd, int channel, uint16_t *reading);

#endif /* ADCHW_H */
