/****************************************************************************
  FERAL ROBOT - URBAN TAPESTRIES (http://urbantapestries.org/)
  Linux-based robot client for gumstix platform
  Author: Dima Diall
****************************************************************************/

#ifndef UTROBOT_H
#define UTROBOT_H

#include <stdint.h>
#include <time.h>

// TODO: adjust sleep time!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#define SLEEP_USEC          (2 * 1000000)

#define UT_SERVER_PORT      1979				// Not needed anymore since nothing is sent to server

#define GPSD_ADDR           "127.0.0.1"
#define GPSD_PORT           "2947"

#define ADC_SERIAL_PORT     "/dev/ttyS2"

#define LEN_MAC             6
#define LEN_ID              4

#define PROTO_VER           1
#define PKT_STAT_INIT       (PROTO_VER << 12)
#define PKT_STAT_GPS_FIX    11

#define SET_BIT(val, bit)   (val |= (1 << (bit)))
#define CLR_BIT(val, bit)   (val &= ~(1 << (bit)))

// FIXME: temporary workaround... consider using XDR instead
// Network byte ordering of floats on little endian systems
typedef union {
    float f;
    long l;
} netfloat_t;

// Basic packet structure for sensor readings
typedef struct {
    uint16_t status;        // protocol version and status flags
    char robot_id[LEN_MAC]; // robot identifier (MAC address)
    netfloat_t latitude;    // GPS reading of latitude
    netfloat_t longitude;   // GPS reading of longitude
    time_t timestamp;       // date/time (as Unix time)
    char sensor_id[LEN_ID]; // Internal code for sensor type
    netfloat_t sensor_val;  // Sensor reading converted to real value
} packet_t;

#endif /* UTROBOT_H */
